// TODO: Put public facing types in this file.

import 'dart:math';

/// Checks if you are awesome. Spoiler: you are.

class Deck {
  List<int> _deck;
  bool _shuffled = false;
  int _seed;

  List<int> get deck => _deck;
  set deck(List<int> deck) {
    _deck = deck;
    _shuffled = true;
  }

  bool get shuffled => _shuffled;

  Deck.defaultDeck(this._seed) : _deck = _getDefaultList();

  String toString() => _deck.toString();

  void shuffle(ShuffleStrategy strategy) {
    strategy._shuffle(this, _seed);
  }

  static List<int> _getDefaultList() {
    List<int> deck = [];
    for (int i = 0; i < 52; i++) {
      deck.add(i);
    }

    return deck;
  }
}

class ShuffleStrategy {
  int _iterations;
  ShuffleIteration _strategy;

  int get iterations => _iterations;

  ShuffleStrategy(this._iterations, this._strategy);

  void _shuffle(Deck deck, int seed) {
    List<int> list = deck.deck;
    Random r = Random(seed);
    for (int i = 0; i < _iterations; i++) {
      list = _strategy.call(list, r);
    }
    deck.deck = list;
  }
}

typedef List<int> ShuffleIteration(List<int> deck, Random r);
